## calc 2.15.1.0

=== Makefile ===
#!/usr/bin/env make
#
# calc - arbitrary precision calculator
#
# Copyright (C) 1999-2018,2021-2023  Landon Curt Noll
#
# Suggestion: Read the HOWTO.INSTALL file.
#
# Calc is open software; you can redistribute it and/or modify it under
# the terms of version 2.1 of the GNU Lesser General Public License
# as published by the Free Software Foundation.
#
# Calc is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General
# Public License for more details.
#
# A copy of version 2.1 of the GNU Lesser General Public License is
# distributed with calc under the filename COPYING-LGPL.  You should have
# received a copy with calc; if not, write to Free Software Foundation, Inc.
# 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
#
# Under source code control:	1990/02/15 01:48:41
# File existed as early as:	before 1990
#
# This calculator first developed by David I. Bell with help/mods from others.
#
# chongo <was here> /\oo/\	http://www.isthe.com/chongo/
# Share and enjoy!  :-)		http://www.isthe.com/chongo/tech/comp/calc/


# SUGGESTION: Instead of modifying this file, consider adding
#	      statements to modify, replace or append Makefile
#	      variables in the Makefile.local file.


###########################################
# Files used or included by this Makefile #
###########################################

# Normally certain files depend on the Makefile.  If the Makefile is
# changed, then certain steps should be redone.  If MAKE_FILE is
# set to Makefile, then these files will depend on Makefile.  If
# MAKE_FILE is empty, then they won't.
#
# If in doubt, set MAKE_FILE to Makefile
#
MAKE_FILE= Makefile

# Calc configuration and compile configuration values
#
CONFIG_MKF= Makefile.config

# Host target information.
#
TARGET_MKF= Makefile.target

# Local file that is included just prior to the first rule,
# that allows one to override any values set in this Makefile.
#
LOCAL_MKF= Makefile.local

# The set of Makefiles
#
MK_SET= ${MAKE_FILE} ${CONFIG_MKF} ${TARGET_MKF} ${LOCAL_MKF}


#######################################################
# Calc configuration and compile configuration values #
#######################################################
include ${CONFIG_MKF}


###############################
# host target section include #
###############################
include ${TARGET_MKF}


##########################################################################
#=-=-=-=-=- Be careful if you change something below this line -=-=-=-=-=#
##########################################################################

# Makefile debug
#
# Q=@	do not echo internal Makefile actions (quiet mode)
# Q=	echo internal Makefile actions (debug / verbose mode)
#
# H=@:	do not report hsrc file formation progress
# H=@	echo hsrc file formation progress
#
# S= >/dev/null 2>&1	silence ${CC} output during hsrc file formation
# S=			full ${CC} output during hsrc file formation
#
# E= 2>/dev/null	silence command stderr during hsrc file formation
# E=			full command stderr during hsrc file formation
#
# V=@:	do not echo debug statements (quiet mode)
# V=@	echo debug statements (debug / verbose mode)
#
# To turn all messages, use:
#
# Q=
# H=@
# S=
# E=
# V=@
#
#Q=
Q=@
#
S= >/dev/null 2>&1
#S=
#
E= 2>/dev/null
#E=
#
#H=@:
H=@
#
V=@:
#V=@

# the source files which are built into a math link library
#
# There MUST be a .o for every .c in LIBOBJS
#
LIBSRC= addop.c assocfunc.c blkcpy.c block.c byteswap.c \
	codegen.c comfunc.c commath.c config.c const.c custom.c \
	errtbl.c file.c func.c hash.c help.c hist.c input.c jump.c label.c \
	lib_calc.c lib_util.c listfunc.c matfunc.c math_error.c \
	obj.c opcodes.c pix.c poly.c prime.c qfunc.c qio.c \
	qmath.c qmod.c qtrans.c quickhash.c seed.c sha1.c size.c \
	str.c strl.c symbol.c token.c value.c version.c zfunc.c zio.c \
	zmath.c zmod.c zmul.c zprime.c zrand.c zrandom.c

# the object files which are built into a math link library
#
# There MUST be a .o for every .c in LIBSRC
# which is built via this Makefile.
#
LIBOBJS= addop.o assocfunc.o blkcpy.o block.o byteswap.o \
	codegen.o comfunc.o commath.o config.o const.o custom.o \
	errtbl.o file.o func.o hash.o help.o hist.o input.o jump.o label.o \
	lib_calc.o lib_util.o listfunc.o matfunc.o math_error.o \
	obj.o opcodes.o pix.o poly.o prime.o qfunc.o qio.o \
	qmath.o qmod.o qtrans.o quickhash.o seed.o sha1.o size.o \
	str.o strl.o symbol.o token.o value.o version.o zfunc.o zio.o \
	zmath.o zmod.o zmul.o zprime.o zrand.o zrandom.o

# the calculator source files
#
# There MUST be a .c for every .o in CALCOBJS.
#
CALCSRC= calc.c

# we build these .o files for calc
#
# There MUST be a .o for every .c in CALCSRC.
#
CALCOBJS= calc.o

# these .h files are needed to build the math link library
#
LIB_H_SRC= alloc.h attribute.h banned.h blkcpy.h block.h bool.h byteswap.h \
	calc.h cmath.h config.h custom.h decl.h errtbl.h file.h func.h \
	hash.h hist.h int.h jump.h label.h lib_calc.h lib_util.h nametype.h \
	opcodes.h prime.h qmath.h sha1.h str.h strl.h symbol.h token.h \
	value.h version.h zmath.h zrand.h zrandom.h

# we build these .h files during the make
#
BUILD_H_SRC= align32.h args.h charbit.h conf.h endian_calc.h errsym.h fposval.h \
	have_arc4random.h have_ban_pragma.h have_const.h have_environ.h \
	have_fgetsetpos.h have_fpos_pos.h have_getpgid.h have_getprid.h \
	have_getsid.h have_gettime.h have_inttypes.h have_limits.h have_memmv.h \
	have_newstr.h have_offscl.h have_posscl.h have_rusage.h have_statfs.h \
	have_stdbool.h have_stdint.h have_stdlib.h have_strdup.h have_string.h \
	have_strlcat.h have_strlcpy.h have_sys_mount.h have_sys_param.h \
	have_sys_vfs.h have_times.h have_uid_t.h have_unistd.h have_unused.h \
	have_urandom.h have_ustat.h longbits.h status.chk_c.h terminal.h

# we build these .c files during the make
#
BUILD_C_SRC=

# these .c files may be used in the process of building BUILD_H_SRC
#
# There MUST be a .c for every .o in UTIL_OBJS.
#
UTIL_C_SRC= align32.c charbit.c chk_c.c endian.c fposval.c have_arc4random.c \
	have_ban_pragma.c have_const.c have_environ.c have_fgetsetpos.c \
	have_fpos_pos.c have_getpgid.c have_getprid.c have_getsid.c \
	have_gettime.c have_memmv.c have_newstr.c have_offscl.c have_posscl.c \
	have_rusage.c have_statfs.c have_stdvs.c have_strdup.c have_strlcat.c \
	have_strlcpy.c have_uid_t.c have_unused.c have_ustat.c have_varvs.c \
	longbits.c

# these awk and sed tools are used in the process of building BUILD_H_SRC
# and BUILD_C_SRC
#
UTIL_MISC_SRC= fposval.h.def

# these .o files may get built in the process of building BUILD_H_SRC
#
# There MUST be a .o for every .c in UTIL_C_SRC.
#
UTIL_OBJS= endian.o longbits.o have_newstr.o have_uid_t.o \
	have_const.o fposval.o have_fgetsetpos.o have_fpos_pos.o \
	try_strarg.o have_stdvs.o have_varvs.o have_posscl.o have_memmv.o \
	have_ustat.o have_getsid.o have_getpgid.o have_environ.o \
	have_gettime.o have_getprid.o ver_calc.o have_rusage.o have_strdup.o \
	have_unused.o have_ban_pragma.o have_strlcpy.o have_strlcat.o \
	have_arc4random.o charbit.o have_statfs.o chk_c.o

# these temp files may be created (and removed) during the build of BUILD_C_SRC
#
UTIL_TMP= ll_tmp fpos_tmp fposval_tmp const_tmp uid_tmp newstr_tmp vs_tmp \
	memmv_tmp offscl_tmp posscl_tmp newstr_tmp \
	getsid_tmp gettime_tmp getprid_tmp rusage_tmp strdup_tmp

# these utility executables may be created in the process of
# building the BUILD_H_SRC file set
#
UTIL_PROGS= align32${EXT} fposval${EXT} have_uid_t${EXT} have_const${EXT} \
	endian${EXT} longbits${EXT} have_newstr${EXT} have_stdvs${EXT} \
	have_varvs${EXT} have_ustat${EXT} have_getsid${EXT} \
	have_getpgid${EXT} have_gettime${EXT} have_getprid${EXT} \
	ver_calc${EXT} have_strdup${EXT} have_environ{EXT} \
	have_unused${EXT} have_fpos${EXT} have_fpos_pos${EXT} \
	have_offscl${EXT} have_rusage${EXT} have_ban_pragma${EXT} \
	have_strlcpy${EXT} have_strlcat${EXT} have_arc4random${EXT} \
	charbit${EXT} have_statfs${EXT} chk_c${EXT}

# these utility files and scripts may be created in the process of building
# the BUILD_H_SRC file set
#
UTIL_FILES= have_args.sh

# Any .h files that are needed to compile sample code.
#
SAMPLE_H_SRC=

# Any .c files that are needed to compile sample code.
#
# There MUST be a .c in SAMPLE_C_SRC for every .o in SAMPLE_OBJ.
#
SAMPLE_C_SRC= sample_many.c sample_rand.c

# Any .o files that are needed to compile sample code.
#
# There MUST be a .c in SAMPLE_C_SRC for every .o in SAMPLE_OBJ.
#
SAMPLE_OBJ= sample_many.o sample_rand.o

# complete list of .h files found (but not built) in the distribution
#
H_SRC= ${LIB_H_SRC} ${SAMPLE_H_SRC}

# complete list of .c files found (but not built) in the distribution
#
C_SRC= ${LIBSRC} ${CALCSRC} ${UTIL_C_SRC} ${SAMPLE_C_SRC}

# The list of files that describe calc's GNU Lesser General Public License
#
LICENSE= COPYING COPYING-LGPL

# These files are found (but not built) in the distribution
#
DISTLIST= ${C_SRC} ${H_SRC} ${MK_SET} ${UTIL_MISC_SRC} ${LICENSE} \
	BUGS calc.man calc.spec.in CHANGES check.awk chk_tree CONTRIB-CODE \
	HOWTO.INSTALL LIBRARY .lldbinit QUESTIONS README.FIRST README.md \
	README.RELEASE README.WINDOWS rpm.mk sample.README trailblank update_ver

# These files are used to make (but not build) a calc .a link library
#
CALCLIBLIST= ${LIBSRC} ${UTIL_C_SRC} ${LIB_H_SRC} ${MK_SET} \
	     ${UTIL_MISC_SRC} BUGS CHANGES LIBRARY

# complete list of .o files
#
OBJS= ${LIBOBJS} ${CALCOBJS} ${UTIL_OBJS} ${SAMPLE_OBJ}

# Static library build
# Libraries created and used to build calc
# Symlinks of dynamic shared libraries
# Early targets - things needed before the main build phase can begin
#
CALC_STATIC_LIBS= libcalc.a libcustcalc.a
CALC_DYNAMIC_LIBS= libcalc${LIB_EXT_VERSION} libcustcalc${LIB_EXT_VERSION}
SYM_DYNAMIC_LIBS= libcalc${LIB_EXT} libcustcalc${LIB_EXT} \
	libcalc${LIB_EXT_VER} libcustcalc${LIB_EXT_VER}
EARLY_TARGETS= errsym.h hsrc .hsrc custom/.all custom/Makefile

# list of sample programs that need to be built to satisfy sample rule
#
# NOTE: The ${SAMPLE_TARGETS} and ${SAMPLE_STATIC_TARGETS} are built but
#	not installed at this time.
#
# NOTE: There must be a foo-static${EXT} in SAMPLE_STATIC_TARGETS for
#	every foo${EXT} in ${SAMPLE_TARGETS}.
#
SAMPLE_TARGETS= sample_rand${EXT} sample_many${EXT}
SAMPLE_STATIC_TARGETS= sample_rand-static${EXT} sample_many-static${EXT}

# list of cscript programs that need to be built to satisfy cscript/.all
#
# NOTE: This list MUST be coordinated with the ${CSCRIPT_TARGETS} variable
#	in the cscript/Makefile
#
CSCRIPT_TARGETS= cscript/mersenne cscript/piforever cscript/plus \
		 cscript/square cscript/fproduct cscript/powerterm

# dynamic first targets
#
DYNAMIC_FIRST_TARGETS= ${LICENSE} .dynamic

# static first targets
#
STATIC_FIRST_TARGETS= ${LICENSE} .static

# late targets - things needed after the main build phase is complete
#
LATE_TARGETS= calc.1 calc.usage calc.cat1 \
	      cal/.all help/.all help/builtin help/errorcodes \
	      cscript/.all

# calc tools - tools used by the maintainers of the calc source base
#
# Calc supplied tools:
#
# TRAILBLANK	- find trailing blanks and other file format picky issues
# UPDATE_VER	- update version numbers in Makefile.config
# CALC_TOOLS	- the complete list of calc supplied tools
#
TRAILBLANK= trailblank
UPDATE_VER= update_ver
CALC_TOOLS= ${TRAILBLANK} ${UPDATE_VER}

# complete list of files that may be created as part of the build process
#
# Used by chk_tree via make prep
#
BUILD_ALL= ${LIBOBJS} ${CALCOBJS} ${BUILD_H_SRC} ${BUILD_C_SRC} \
	   ${UTIL_OBJS} ${UTIL_TMP} ${UTIL_PROGS} ${SAMPLE_OBJ} \
	   ${CALC_STATIC_LIBS} ${CALC_DYNAMIC_LIBS} ${SYM_DYNAMIC_LIBS} \
	   ${SAMPLE_TARGETS} ${SAMPLE_STATIC_TARGETS} ${CSCRIPT_TARGETS} \
	   .dynamic .static ${LATE_TARGETS} calc${EXT} errcode${EXT} \
	   tags .hsrc outfile

# complete list of targets
#

=== cal/Makefile ===
#!/usr/bin/env make
#
# cal - makefile for calc standard resource files
#
# Copyright (C) 1999-2006,2017,2021-2023  Landon Curt Noll
#
# Suggestion: Read the ../HOWTO.INSTALL file.
#
# Calc is open software; you can redistribute it and/or modify it under
# the terms of the version 2.1 of the GNU Lesser General Public License
# as published by the Free Software Foundation.
#
# Calc is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU Lesser General
# Public License for more details.
#
# A copy of version 2.1 of the GNU Lesser General Public License is
# distributed with calc under the filename COPYING-LGPL.  You should have
# received a copy with calc; if not, write to Free Software Foundation, Inc.
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
# Under source code control:	1991/07/21 05:00:54
# File existed as early as:	1991
#
# This calculator first developed by David I. Bell with help/mods from others.
#
# chongo <was here> /\oo/\	http://www.isthe.com/chongo/
# Share and enjoy!  :-)		http://www.isthe.com/chongo/tech/comp/calc/


# SUGGESTION: Instead of modifying this file, consider adding
#	      statements to modify, replace or append Makefile
#	      variables in the ../Makefile.local file.


###########################################
# Files used or included by this Makefile #
###########################################

# Normally certain files depend on the Makefile.  If the Makefile is
# changed, then certain steps should be redone.  If MAKE_FILE is
# set to Makefile, then these files will depend on Makefile.  If
# MAKE_FILE is empty, then they won't.
#
# If in doubt, set MAKE_FILE to Makefile
#
MAKE_FILE= Makefile

# Calc configuration and compile configuration values
#
CONFIG_MKF= ../Makefile.config

# Host target information.
#
TARGET_MKF= ../Makefile.target

# Local file that is included just prior to the first rule,
# that allows one to override any values set in this Makefile.
#
LOCAL_MKF= ../Makefile.local

# The set of Makefiles
#
MK_SET= ${MAKE_FILE} ${CONFIG_MKF} ${TARGET_MKF} ${LOCAL_MKF}


#######################################################
# Calc configuration and compile configuration values #
#######################################################
include ${CONFIG_MKF}


###############################
# host target section include #
###############################
include ${TARGET_MKF}


##########################################################################
#=-=-=-=-=- Be careful if you change something below this line -=-=-=-=-=#
##########################################################################


# Makefile debug
#
# Q=@	do not echo internal Makefile actions (quiet mode)
# Q=	echo internal Makefile actions (debug / verbose mode)
#
# H=@:	do not report hsrc file formation progress
# H=@	do echo hsrc file formation progress
#
# S= >/dev/null 2>&1	silence ${CC} output during hsrc file formation
# S=			full ${CC} output during hsrc file formation
#
# E= 2>/dev/null	silence command stderr during hsrc file formation
# E=			full command stderr during hsrc file formation
#
# V=@:	do not echo debug statements (quiet mode)
# V=@	do echo debug statements (debug / verbose mode)
#
#Q=
Q=@
#
S= >/dev/null 2>&1
#S=
#
E= 2>/dev/null
#E=
#
#H=@:
H=@
#
V=@:
#V=@

# The calc files to install
#
# This list is produced by the detaillist rule when no WARNINGS are detected.
#
# Please use:
#
#	make clobber >/dev/null && make calc_files_list
#
# to keep this list in nice sorted order.
#
CALC_FILES= README alg_config.cal beer.cal bernoulli.cal \
	bernpoly.cal bigprime.cal bindings brentsolve.cal chi.cal chrem.cal \
	comma.cal constants.cal deg.cal dms.cal dotest.cal ellip.cal \
	factorial.cal factorial2.cal fnv_tool.cal gvec.cal hello.cal hms.cal \
	infinities.cal intfile.cal intnum.cal lambertw.cal linear.cal \
	lnseries.cal lucas.cal lucas_chk.cal mersenne.cal mfactor.cal mod.cal \
	natnumset.cal palindrome.cal pell.cal pi.cal pix.cal pollard.cal \
	poly.cal prompt.cal psqrt.cal qtime.cal quat.cal randbitrun.cal \
	randmprime.cal randombitrun.cal randomrun.cal randrun.cal regress.cal \
	repeat.cal screen.cal seedrandom.cal set8700.line smallfactors.cal \
	solve.cal specialfunctions.cal splitbits.cal statistics.cal \
	strings.cal sumsq.cal sumtimes.cal surd.cal test2300.obj_incdec.cal \
	test2600.numfunc.cal test2700.isqrt.cal test3100.matobj.cal \
	test3300.det.cal test3400.trig.cal test4000.ptest.cal \
	test4100.redc.cal test4600.fileop.cal test5100.newdecl.cal \
	test5200.globstat.cal test8000.read.cal test8400.quit.cal \
	test8500.divmod.cal test8600.maxargs.cal test8700.dotest.cal \
	test8900.special.cal test9300.frem.cal test9500.trigeq.cal \
	toomcook.cal unitfrac.cal varargs.cal write2file.cal xx_print.cal \
	zeta2.cal

# These calc files are now obsolete and are removed by the install rule.
#
DEAD_CALC_FILES= lucas_tbl.cal set8700.cal test1700.cal test2300.cal test2600.cal \
	test2700.cal test3100.cal test3300.cal test3400.cal test3500.cal test4000.cal \
	test4100.cal test4600.cal test5100.cal test5200.cal test8400.cal test8500.cal \
	test8600.cal test8900.cal

# These files are found (but not built) in the distribution
#
DISTLIST= ${CALC_FILES} ${MAKE_FILE}

# These files are used to make (but not built) a calc .a link library
#
CALCLIBLIST=

# rules that are not also names of files
#
PHONY= all distlist buildlist distdir calcliblist calc_files_list echo_inst_files \
	clean clobber install uninstall


############################################################
# Allow Makefile.local to change any of the above settings #
############################################################
include ${LOCAL_MKF}


###########################################
# all - First and default Makefile target #
###########################################

all: ${CALC_FILES} ${MAKE_FILE} .all


###############################
# additional Makefile targets #
###############################

.PHONY: ${PHONY}

# used by the upper level Makefile to determine of we have done all
#
.all:
	${RM} -f .all
	${TOUCH} .all

##
#
# File list generation.	 You can ignore this section.
#
#
# We will form the names of source files as if they were in a
# sub-directory called calc/cal.
#
# NOTE: Due to bogus shells found on one common system we must have
#	an non-empty else clause for every if condition.  *sigh*
#
##

distlist: ${DISTLIST}
	${Q} for i in ${DISTLIST} /dev/null; do \
	    if [ X"$$i" != X"/dev/null" ]; then \
		echo cal/$$i; \
	    fi; \
	done

buildlist:
	${Q} for i in ${BUILD_ALL} /dev/null; do \
	    if [ X"$$i" != X"/dev/null" ]; then \
		echo cal/$$i; \
	    fi; \
	done | fgrep -v '.bak' | LANG=C ${SORT}

distdir:
	${Q} echo cal

calcliblist:
	${Q} for i in ${CALCLIBLIST} /dev/null; do \
	    if [ X"$$i" != X"/dev/null" ]; then \
		echo cal/$$i; \
	    fi; \
	done

# These next rule help form the ${CALC_FILES} makefile variables above.
#
calc_files_list:
	${Q} -(find .  -mindepth 1 -maxdepth 1 -type f -name '*.cal' -print | \
	    while read i; do \
		echo $$i; \
	    done; \
	    echo '--first_line--'; \
	    echo README; \
	    echo set8700.line; \
	    echo bindings) | \
	    ${SED} -e 's:^\./::' | LANG=C ${SORT} | ${FMT} -70 | \
	    ${SED} -e '1s/--first_line--/CALC_FILES=/' -e '2,$$s/^/	/' \
		   -e 's/$$/ \\/' -e '$$s/ \\$$//'

##
#
# rpm rules
#
##

echo_inst_files:
	${Q} for i in ${CALC_FILES} /dev/null; do \
	    if [ X"$$i" != X"/dev/null" ]; then \
		echo __file__ ${CALC_SHAREDIR}/$$i; \
	    fi; \
	done

##
#
# Utility rules
#
##

clean:

clobber: clean
	${RM} -f .all
	-${Q} if [ -e .DS_Store ]; then \
	    echo ${RM} -rf .DS_Store; \
	    ${RM} -rf .DS_Store; \
	fi
	-${Q} for i in ${DEAD_CALC_FILES} test082.cal outfile /dev/null; do \
	    if [ "$$i" = "/dev/null" ]; then \
		continue; \
	    fi; \
	    if [ -e "./$$i" ]; then \
		echo "${RM} -f ./$$i"; \
		${RM} -f ./$$i; \
	    fi; \
	done

# install everything
#
# NOTE: Keep the uninstall rule in reverse order to the install rule
#
install: all
	-${Q} if [ ! -d ${T}${CALC_SHAREDIR} ]; then \
	    echo ${MKDIR} -p ${T}${CALC_SHAREDIR}; \
	    ${MKDIR} -p ${T}${CALC_SHAREDIR}; \
	    if [ ! -d "${T}${CALC_SHAREDIR}" ]; then \
		echo ${MKDIR} -p "${T}${CALC_SHAREDIR}"; \
		${MKDIR} -p "${T}${CALC_SHAREDIR}"; \
	    fi; \
	    echo ${CHMOD} 0755 ${T}${CALC_SHAREDIR}; \
	    ${CHMOD} 0755 ${T}${CALC_SHAREDIR}; \
	else \
	    ${TRUE}; \
	fi
	${Q} for i in ${CALC_FILES} /dev/null; do \
	    if [ "$$i" = "/dev/null" ]; then \
		continue; \
	    fi; \
	    if ${CMP} -s $$i ${T}${CALC_SHAREDIR}/$$i; then \
		${TRUE}; \
	    else \
		${RM} -f ${T}${CALC_SHAREDIR}/$$i.new; \
		${CP} -f $$i ${T}${CALC_SHAREDIR}/$$i.new; \
		${CHMOD} 0444 ${T}${CALC_SHAREDIR}/$$i.new; \
		${MV} -f ${T}${CALC_SHAREDIR}/$$i.new ${T}${CALC_SHAREDIR}/$$i;\
		echo "installed ${T}${CALC_SHAREDIR}/$$i"; \
	    fi; \
	done
	${Q} for i in ${DEAD_CALC_FILES} /dev/null; do \
	    if [ "$$i" = "/dev/null" ]; then \
		continue; \
	    fi; \
	    if [ -e "${T}${CALC_SHAREDIR}/$$i" ]; then \
		echo "${RM} -f ${T}${CALC_SHAREDIR}/$$i"; \
		${RM} -f ${T}${CALC_SHAREDIR}/$$i; \
	    fi; \
	    if [ -e "./$$i" ]; then \
		echo "${RM} -f ./$$i"; \
		${RM} -f ./$$i; \
	    fi; \
	done

# Try to remove everything that was installed
#
# NOTE: Keep the uninstall rule in reverse order to the install rule
#
uninstall:
	- ${Q} for i in ${DEAD_CALC_FILES} /dev/null; do \
	    if [ "$$i" = "/dev/null" ]; then \
		continue; \
	    fi; \
	    if [ -e "${T}${CALC_SHAREDIR}/$$i" ]; then \
		echo "${RM} -f ${T}${CALC_SHAREDIR}/$$i"; \
		${RM} -f ${T}${CALC_SHAREDIR}/$$i; \
	    fi; \
	    if [ -e "./$$i" ]; then \
		echo "${RM} -f ./$$i"; \
		${RM} -f ./$$i; \
	    fi; \
	done
	-${Q} for i in ${CALC_FILES} /dev/null; do \
	    if [ "$$i" = "/dev/null" ]; then \
		continue; \
	    fi; \
	    if [ -f "${T}${CALC_SHAREDIR}/$$i" ]; then \
		${RM} -f "${T}${CALC_SHAREDIR}/$$i"; \
		if [ -f "${T}${CALC_SHAREDIR}/$$i" ]; then \
		   echo "cannot uninstall ${T}${CALC_SHAREDIR}/$$i"; \
		else \
		   echo "un-installed ${T}${CALC_SHAREDIR}/$$i"; \
		fi; \
	    fi; \
	done
	-${Q} for i in ${CALC_SHAREDIR}; do \
	    if [ -d "${T}$$i" ]; then \
		${RMDIR} "${T}$$i" 2>/dev/null; \
		echo "cleaned up ${T}$$i"; \
	    fi; \
	done

=== custom/Makefile ===
#!/usr/bin/env make
#
# custom - makefile for calc custom routines
#
# Copyright (C) 1999-2006,2014,2017-2018,2021,2023  Landon Curt Noll
#
# Suggestion: Read the ../HOWTO.INSTALL file.
#
# Calc is open software; you can redistribute it and/or modify it under
# the terms of the version 2.1 of the GNU Lesser General Public License
# as published by the Free Software Foundation.
#
# Calc is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU Lesser General
# Public License for more details.
#
# A copy of version 2.1 of the GNU Lesser General Public License is
# distributed with calc under the filename COPYING-LGPL.  You should have
# received a copy with calc; if not, write to Free Software Foundation, Inc.
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
# Under source code control:	1997/03/09 02:28:54
# File existed as early as:	1997
#
# This calculator first developed by David I. Bell with help/mods from others.
#
# chongo <was here> /\oo/\	http://www.isthe.com/chongo/
# Share and enjoy!  :-)		http://www.isthe.com/chongo/tech/comp/calc/


# SUGGESTION: Instead of modifying this file, consider adding
#	      statements to modify, replace or append Makefile
#	      variables in the ../Makefile.local file.


###########################################
# Files used or included by this Makefile #
###########################################

# Normally certain files depend on the Makefile.  If the Makefile is
# changed, then certain steps should be redone.  If MAKE_FILE is
# set to Makefile, then these files will depend on Makefile.  If
# MAKE_FILE is empty, then they won't.
#
# If in doubt, set MAKE_FILE to Makefile
#
MAKE_FILE= Makefile

# Calc configuration and compile configuration values
#
CONFIG_MKF= ../Makefile.config

# Host targets that are shared in common with both Makefile
# and custom/Makefile.
#
TARGET_MKF= ../Makefile.target

# Host target information.
#
LOCAL_MKF= ../Makefile.local

# The set of Makefiles
#
MK_SET= ${MAKE_FILE} ${CONFIG_MKF} ${TARGET_MKF} ${LOCAL_MKF}


#######################################################
# Calc configuration and compile configuration values #
#######################################################
include ${CONFIG_MKF}


###############################
# host target section include #
###############################
include ${TARGET_MKF}


##################################
# Files managed by this Makefile #
##################################

# The custom calc resource files to install
#
# Put your custom calc resource files here.
#
CUSTOM_CALC_FILES= argv.cal halflen.cal pzasusb8.cal pmodm127.cal register.cal

# The custom help files to install
#
# Put your custom help files here.
#
CUSTOM_HELP= argv devnull help sysinfo pzasusb8 pmodm127 register

# Any .h files that are needed by programs that use
# libcustcalc${LIB_EXT_VERSION}
#
# Put any .h files that you add which might be useful to other
# programs here.
#
CUSTOM_H_SRC=

# Any .c files that are needed to build libcustcalc${LIB_EXT_VERSION}.
#
# Don't put ${REQUIRED_SRC} files in this list.
#
# There MUST be a .c in CUSTOM_SRC for every .o in CUSTOM_OBJ.
#
# Put your custom .c files here.
#
CUSTOM_SRC= c_argv.c c_devnull.c c_help.c c_sysinfo.c c_pzasusb8.c \
	c_pmodm127.c c_register.c

# Any .o files that are needed by program that use
# libcustcalc${LIB_EXT_VERSION}.
#
# Don't put ${REQUIRED_OBJ} files in this list.
#
# There MUST be a .c in CUSTOM_SRC for every .o in CUSTOM_OBJ.
#
# Put your custom .o files here.
#
CUSTOM_OBJ= c_argv.o c_devnull.o c_help.o c_sysinfo.o c_pzasusb8.o \
	c_pmodm127.o c_register.o


##########################################################################
#=-=-=-=-=- Be careful if you change something below this line -=-=-=-=-=#
##########################################################################

# Makefile debug
#
# Q=@	do not echo internal Makefile actions (quiet mode)
# Q=	echo internal Makefile actions (debug / verbose mode)
#
# H=@:	do not report hsrc file formation progress
# H=@	do echo hsrc file formation progress
#
# S= >/dev/null 2>&1	silence ${CC} output during hsrc file formation
# S=			full ${CC} output during hsrc file formation
#
# E= 2>/dev/null	silence command stderr during hsrc file formation
# E=			full command stderr during hsrc file formation
#
# V=@:	do not echo debug statements (quiet mode)
# V=@	do echo debug statements (debug / verbose mode)
#
#Q=
Q=@
#
S= >/dev/null 2>&1
#S=
#
E= 2>/dev/null
#E=
#
#H=@:
H=@
#
V=@:
#V=@

# These .c files are required for the main custom interface and
# for the custom support functions for libcustcalc${LIB_EXT_VERSION}.
#
# There MUST be a .c for every .o in REQUIRED_OBJ.
#
REQUIRED_SRC= custtbl.c

# These .o files correspond to the .c files in REQUIRED_SRC
# for libcustcalc${LIB_EXT_VERSION}.
#
# There MUST be a .o for every .c in REQUIRED_SRC.
#
REQUIRED_OBJ= custtbl.o

# These .h files are installed under ${CUSTOMCALDIR} by the install rule.
#
INSTALL_H_SRC= ${CUSTOM_H_SRC}

# These .c files are used to form libcustcalc${LIB_EXT_VERSION}.
#
CUSTCALC_SRC= ${REQUIRED_SRC} ${CUSTOM_SRC}

# These .o files are used to form libcustcalc${LIB_EXT_VERSION}.
#
CUSTCALC_OBJ= ${REQUIRED_OBJ} ${CUSTOM_OBJ}

# These .c files are used to build the dependency list
#
C_SRC= ${REQUIRED_SRC} ${CUSTOM_SRC}

# These .h files are used to build the dependency list
#
H_SRC= ${CUSTOM_H_SRC}

# These files are found (but not built) in the distribution
#
# The CUSTOM_CAL and HOW_TO_ADD are files distributed from this
# directory but are installed as help files from the help/Makefile.
#
DISTLIST= ${CUSTCALC_SRC} ${CUSTOM_CALC_FILES} ${CUSTOM_HELP} \
	${INSTALL_H_SRC} CUSTOM_CAL HOW_TO_ADD Makefile

# These files are used to make (but not built) a calc .a link library
#
CALCLIBLIST= ${CUSTCALC_SRC} ${INSTALL_H_SRC} ${MAKE_FILE} HOW_TO_ADD

# This is the custom dynamic shared library that is build
#
CALC_DYNAMIC_LIBCUSTCALC= libcustcalc${LIB_EXT_VERSION}

# This is the custom static library that is build
#
CALC_STATIC_LIBCUSTCALC= libcustcalc.a

# complete list of files that may be created as part of the build process
#
# Used by chk_tree via make prep
#
BUILD_ALL= ${REQUIRED_OBJ} ${CUSTOM_OBJ} \
	${CALC_DYNAMIC_LIBCUSTCALC} ${CALC_STATIC_LIBCUSTCALC} \
	.all

# complete list of targets
#
TARGETS= ${BLD_TYPE}

# rules that are not also names of files
#
PHONY= all distlist buildlist distdir calcliblist depend echo_inst_files clean \
	clobber install uninstall


############################################################
# Allow Makefile.local to change any of the above settings #
############################################################
include ${LOCAL_MKF}


###########################################
# all - First and default Makefile target #
###########################################

all: ${TARGETS} ${INSTALL_H_SRC} ${CUSTOM_CALC_FILES} \
	${CUSTOM_HELP} ${MAKE_FILE} .all


###############################
# additional Makefile targets #
###############################

.PHONY: ${PHONY}

calc-dynamic-only: ${CUSTCALC_OBJ} ${CALC_DYNAMIC_LIBCUSTCALC}

calc-static-only: ${CUSTCALC_OBJ} ${CALC_STATIC_LIBCUSTCALC}

custom/libcustcalc${LIB_EXT_VERSION}: libcustcalc${LIB_EXT_VERSION} \
	${CALC_STATIC_LIBCUSTCALC}

libcustcalc${LIB_EXT_VERSION}: ${CUSTCALC_OBJ} ${MAKE_FILE}
	${CC} ${LIBCUSTCALC_SHLIB} ${CUSTCALC_OBJ} -o $@

##
#
# Special .o files
#
##

c_sysinfo.o: c_sysinfo.c ${MAKE_FILE}
	${CC} ${CFLAGS} c_sysinfo.c -c

# to determine of we have done all
#
.all:
	${RM} -f .all
	${TOUCH} .all

###
#
# building calc-static and static lib*.a libraries
#
###

libcustcalc.a: ${CUSTCALC_OBJ} ${MAKE_FILE}
	${RM} -f libcustcalc.a
	${AR} qc libcustcalc.a ${CUSTCALC_OBJ}
	${RANLIB} libcustcalc.a
	${CHMOD} 0644 libcustcalc.a

##
#
# File list generation.	 You can ignore this section.
#
#
# We will form the names of source files as if they were in a
# sub-directory called calc/lib.
#
# NOTE: Due to bogus shells found on one common system we must have
#	an non-empty else clause for every if condition.  *sigh*
#
##

distlist: ${DISTLIST}
	${Q} for i in ${DISTLIST} /dev/null; do \
	    if [ X"$$i" != X"/dev/null" ]; then \
		echo custom/$$i; \
	    fi; \
	done

buildlist:
	${Q} for i in ${BUILD_ALL} /dev/null; do \
	    if [ X"$$i" != X"/dev/null" ]; then \
		echo custom/$$i; \
	    fi; \
	done | fgrep -v '.bak' | LANG=C ${SORT}

distdir:
	${Q} echo custom

calcliblist: ${CALCLIBLIST}
	${Q} for i in ${CALCLIBLIST} /dev/null; do \
	    if [ X"$$i" != X"/dev/null" ]; then \
		echo custom/$$i; \
	    fi; \
	done

Makefile.simple:
	${Q} echo Support for custom/$@ was dropped after the the release of calc v2.14.3.0.

##
#
# Home grown make dependency rules.  Your system make not support
# or have the needed tools.  You can ignore this section.
#
# We will form a skeleton tree of *.c files containing only #include "foo.h"
# lines and .h files containing the same lines surrounded by multiple include
# prevention lines.  This allows us to build a static depend list that will
# satisfy all possible cpp symbol definition combinations.
#
##

depend:
	${Q} if [ -f ${MAKE_FILE}.bak ]; then \
	    echo "custom/${MAKE_FILE}.bak exists, remove or move it" 1>&2; \
	    exit 1; \
	else \
	    ${TRUE}; \
	fi
	${Q} if type -f ${MAKEDEPEND}; then \
	    ${TRUE}; \
	else \
	    echo "make depend failed: cannot find makedepend command: ${MAKEDEPEND}" 1>&2; \
	    exit 1; \
	fi
	${Q} echo forming custom/skel
	${Q} ${RM} -rf skel
	${Q} ${MKDIR} -p skel
	${Q} ${MKDIR} -p skel/custom
	-${Q} for i in ${C_SRC} /dev/null; do \
	    if [ X"$$i" != X"/dev/null" ]; then \
		${SED} -n '/^#[	 ]*include[	 ]*"/p' \
		    "$$i" > "skel/custom/$$i"; \
	    fi; \
	done
	-${Q} for i in ${H_SRC} /dev/null; do \
	    if [ "$$i" = "/dev/null" ]; then continue; fi; \
	    tag="`echo $$i | ${SED} 's/[\.+,:]/_/g'`"; \
	    echo "#if !defined($$tag)" > "skel/custom/$$i"; \
	    echo "#define $$tag" >> "skel/custom/$$i"; \
	    ${SED} -n '/^#[	 ]*include[	 ]*"/p' "$$i" \
		>> "skel/custom/$$i"; \
	    echo '#endif /* '"$$tag"' */' >> "skel/custom/$$i"; \
	done
	${Q} (cd ..; ${MAKE} -f ${MAKE_FILE} hsrc)
	(cd ..; ${MAKE} -f ${MAKE_FILE} h_list 2>/dev/null) | \
	    while read i; do \
		if [ ! -f "../$$i" ]; then continue; fi; \
		tag="`echo $$i | ${SED} 's/[\.+,:]/_/g'`"; \
		echo "#if !defined($$tag)" > "skel/$$i"; \
		echo "#define $$tag" >> "skel/$$i"; \
		${SED} -n '/^#[	 ]*include[	 ]*"/p' "../$$i" \
		    >> "skel/$$i"; \
		echo '#endif /* '"$$tag"' */' >> "skel/$$i"; \
	    done
	${Q} ${RM} -f skel/custom/makedep.out skel/custom/makedep.in
	${Q} echo custom/skel formed
	${Q} echo forming custom dependency list
	${Q} :> skel/custom/makedep.out
	-${Q} cd skel/custom; ${MAKEDEPEND} \
	    -I../../.. -w 1 -f makedep.out -- \
	    ${CFLAGS} -- \
	    ${C_SRC} 2>/dev/null
	${Q} ${CP} -f skel/custom/makedep.out skel/custom/makedep.in
	${Q} ${SED} -e 's|: ../../|: |' -E < skel/custom/makedep.in | \
	    ${GREP} -E -v /usr/include > skel/custom/makedep.out
	-${Q} for i in ${C_SRC} /dev/null; do \
	    if [ X"$$i" != X"/dev/null" ]; then \
		echo "$$i" | ${SED} 's/^\(.*\)\.c/\1.o: \1.c/'; \
	    fi; \
	done >> skel/custom/makedep.out
	${Q} LANG=C ${SORT} -u skel/custom/makedep.out \
			    -o skel/custom/makedep.out
	${Q} echo custom dependency list formed
	${Q} echo forming new custom/${MAKE_FILE}
	${Q} ${RM} -f ${MAKE_FILE}.bak
	${Q} ${MV} ${MAKE_FILE} ${MAKE_FILE}.bak
	${Q} ${SED} -n '1,/^# DO NOT DELETE THIS LINE/p' \
		    ${MAKE_FILE}.bak > ${MAKE_FILE}
	${Q} ${GREP} -E -v '^#' skel/custom/makedep.out >> ${MAKE_FILE}
	${Q} echo removing skel
	${Q} ${RM} -rf skel
	-${Q} if ${CMP} -s ${MAKE_FILE}.bak ${MAKE_FILE}; then \
	    echo 'custom/${MAKE_FILE} was already up to date'; \
	    echo 'restoring original custom/${MAKE_FILE}'; \
	    ${MV} -f ${MAKE_FILE}.bak ${MAKE_FILE}; \
	else \

=== help/Makefile ===
#!/usr/bin/env make
#
# help - makefile for calc help files
#
# Copyright (C) 1999-2006,2017,2021-2023  Landon Curt Noll
#
# Suggestion: Read the ../HOWTO.INSTALL file.
#
# Calc is open software; you can redistribute it and/or modify it under
# the terms of the version 2.1 of the GNU Lesser General Public License
# as published by the Free Software Foundation.
#
# Calc is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU Lesser General
# Public License for more details.
#
# A copy of version 2.1 of the GNU Lesser General Public License is
# distributed with calc under the filename COPYING-LGPL.  You should have
# received a copy with calc; if not, write to Free Software Foundation, Inc.
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
# Under source code control:	1991/07/23 06:47:57
# File existed as early as:	1991
#
# This calculator first developed by David I. Bell with help/mods from others.
#
# chongo <was here> /\oo/\	http://www.isthe.com/chongo/
# Share and enjoy!  :-)		http://www.isthe.com/chongo/tech/comp/calc/


# SUGGESTION: Instead of modifying this file, consider adding
#	      statements to modify, replace or append Makefile
#	      variables in the ../Makefile.local file.


###########################################
# Files used or included by this Makefile #
###########################################

# Normally certain files depend on the Makefile.  If the Makefile is
# changed, then certain steps should be redone.  If MAKE_FILE is
# set to Makefile, then these files will depend on Makefile.  If
# MAKE_FILE is empty, then they won't.
#
# If in doubt, set MAKE_FILE to Makefile
#
MAKE_FILE= Makefile

# Calc configuration and compile configuration values
#
CONFIG_MKF= ../Makefile.config

# Host targets that are shared in common with both Makefile
# and custom/Makefile.
#
TARGET_MKF= ../Makefile.target

# Host target information.
#
LOCAL_MKF= ../Makefile.local

# The set of Makefiles
#
MK_SET= ${MAKE_FILE} ${CONFIG_MKF} ${TARGET_MKF} ${LOCAL_MKF}


#######################################################
# Calc configuration and compile configuration values #
#######################################################
include ${CONFIG_MKF}


###############################
# host target section include #
###############################
include ${TARGET_MKF}


##########################################################################
#=-=-=-=-=- Be careful if you change something below this line -=-=-=-=-=#
##########################################################################

# Makefile debug
#
# Q=@	do not echo internal Makefile actions (quiet mode)
# Q=	echo internal Makefile actions (debug / verbose mode)
#
# H=@:	do not report hsrc file formation progress
# H=@	do echo hsrc file formation progress
#
# S= >/dev/null 2>&1	silence ${CC} output during hsrc file formation
# S=			full ${CC} output during hsrc file formation
#
# E= 2>/dev/null	silence command stderr during hsrc file formation
# E=			full command stderr during hsrc file formation
#
# V=@:	do not echo debug statements (quiet mode)
# V=@	do echo debug statements (debug / verbose mode)
#
#Q=
Q=@
#
S= >/dev/null 2>&1
#S=
#
E= 2>/dev/null
#E=
#
#H=@:
H=@
#
V=@:
#V=@


##################################
# Files managed by this Makefile #
##################################

STD_HELP_FILES_1= intro overview
BLT_HELP_FILES_1a= calc

STD_HELP_FILES_2= assoc
BLT_HELP_FILES_3= builtin
STD_HELP_FILES_4= command config custom define environment
BLT_HELP_FILES_5= errorcodes
STD_HELP_FILES_6= expression file history interrupt list mat
# because obj is built special (due to confusion with it as
# a symlink for some built environments, we treat obj specially
# and call it obj.file
#
SPECIAL_HELP_7= obj.file
STD_HELP_FILES_8= operator
BLT_HELP_FILES_9= resource
STD_HELP_FILES_10= script statement types unexpected variable

BLT_HELP_FILES_11= bindings custom_cal libcalc new_custom cscript

STD_HELP_FILES_12= archive
BLT_HELP_FILES_13= bugs changes contrib
STD_HELP_FILES_14= todo wishlist

STD_HELP_FILES_15= credit
# copyright is printed by help.c is from the Copyright string found in version.c
BLT_HELP_FILES_16= COPYING COPYING-LGPL questions releases

STD_HELP_FILES_17= help

# These files are used in the following order to construct full
#
FULL_HELP_FILES= ${STD_HELP_FILES_1} ${BLT_HELP_FILES_1a} \
		 ${STD_HELP_FILES_2} \
		 ${BLT_HELP_FILES_3}  ${STD_HELP_FILES_4} \
		 ${BLT_HELP_FILES_5}  ${STD_HELP_FILES_6} \
		 ${SPECIAL_HELP_7}    ${STD_HELP_FILES_8} \
		 ${BLT_HELP_FILES_9}  ${STD_HELP_FILES_10} \
		 ${BLT_HELP_FILES_11} ${STD_HELP_FILES_12} \
		 ${BLT_HELP_FILES_13} ${STD_HELP_FILES_14} \
		 ${STD_HELP_FILES_15} ${BLT_HELP_FILES_16} \
		 ${STD_HELP_FILES_17}

# These full files are those who are not built or constructed
#
STD_HELP_FILES= ${STD_HELP_FILES_1}  ${STD_HELP_FILES_2} \
		${STD_HELP_FILES_4}  ${STD_HELP_FILES_6} \
		${STD_HELP_FILES_8}  ${STD_HELP_FILES_10} \
		${STD_HELP_FILES_12} ${STD_HELP_FILES_14} \
		${STD_HELP_FILES_15} ${STD_HELP_FILES_17}

# These full files are those who are built by this Makefile
#
# Note that ${SPECIAL_HELP_7} is not included in this list
# because of problems with its name.
#
BLT_HELP_FILES= ${BLT_HELP_FILES_1a} \
		${BLT_HELP_FILES_3}  ${BLT_HELP_FILES_5} \
		${BLT_HELP_FILES_9}  ${BLT_HELP_FILES_11} \
		${BLT_HELP_FILES_13} ${BLT_HELP_FILES_16}

# The detailed list of help files to install
#
# This list is produced by the detaillist rule when no WARNINGS are detected.
#
# Please use:
#
#	make clobber >/dev/null && make detail_help_list
#
# to keep this list in nice sorted order.
#
DETAIL_HELP= abs access acos acosh acot acoth acovercos acoversin \
	acrd acsc acsch address aexcsc aexsec agd ahacovercos ahacoversin \
	ahavercos ahaversin append appr arg argv arrow asec asech asin asinh \
	assign atan atan2 atanh avercos aversin avg base base2 bernoulli bit \
	blk blkcpy blkfree blocks bround btrunc calc_tty calclevel calcpath \
	cas catalan ceil cfappr cfsim char cis cmdbuf cmp comb conj cos cosh \
	cot coth count covercos coversin cp crd csc csch ctime d2dm d2dms d2g \
	d2r delete den dereference det digit digits display dms2d dp epsilon \
	errcount errmax errno error errsym estr euler eval excsc exp exsec \
	fact factor fclose fcnt feof ferror fflush fgetc fgetfield fgetfile \
	fgetline fgets fgetstr fib files floor fopen forall fpathopen fprintf \
	fputc fputs fputstr frac free freebernoulli freeeuler freeglobals \
	freeredc freestatics frem freopen fscan fscanf fseek fsize ftell g2d \
	g2gm g2gms g2r gcd gcdrem gd getenv gms2g h2hm h2hms hacovercos \
	hacoversin hash havercos haversin head highbit hmean hms2h hnrmod \
	hypot ilog ilog10 ilog2 im indices inputlevel insert int inverse iroot \
	isalnum isalpha isassoc isatty isblk iscntrl isconfig isdefined \
	isdigit iserror iseven isfile isgraph ishash isident isint islist \
	islower ismat ismult isnull isnum isobj isobjtype isodd isprime \
	isprint isptr ispunct isqrt isrand israndom isreal isrel issimple \
	isspace issq isstr istype isupper isxdigit jacobi join lcm lcmfact \
	lfactor ln log log2 logn lowbit ltol makelist matdim matfill matmax \
	matmin matsum mattrace mattrans max memsize meq min minv mmin mne mod \
	modify name near newerror nextcand nextprime norm null num oldvalue \
	ord param perm pfact pi pix places pmod polar poly pop popcnt pound \
	power prevcand prevprime printf prompt protect ptest push putenv quo \
	quomod r2d r2g rand randbit random randombit randperm rcin rcmul rcout \
	rcpow rcsq re remove reverse rewind rm root round rsearch runtime \
	saveval scale scan scanf search sec sech seed segment select sgn sha1 \
	sin sinh size sizeof sleep sort sqrt srand srandom ssq stoponerror str \
	strcasecmp strcat strcmp strcpy strerror strlen strncasecmp strncmp \
	strncpy strpos strprintf strscan strscanf strtolower strtoupper substr \
	sum swap system systime tail tan tanh test time trunc usertime vercos \
	versin version xor

# This list is of files that are clones of DETAIL_HELP files.  They are
# built from DETAIL_HELP files.
#
DETAIL_CLONE= copy ilogn

# Singular files
#
# These files are copies of their plural form.
#
PLURAL_FILES= bindings bugs changes errorcodes types
SINGULAR_FILES= binding bug change errorcode type

# These files are found (but not built) in the distribution
#
DISTLIST= ${STD_HELP_FILES} ${DETAIL_HELP} ${MAKE_FILE} \
	obj.file builtin.top builtin.end funclist.sed

# These files are used to make (but not built) a calc .a link library
#
CALCLIBLIST=

# complete list of files that may be created as part of the build process
#
# Used by chk_tree via make prep
#
BUILD_ALL= ${BLT_HELP_FILES} ${SINGULAR_FILES} ${DETAIL_CLONE} \
	   full funclist${EXT} funclist.c funclist.o

# rules that are not also names of files
#
PHONY= all distlist buildlist distdir calcliblist detail_help_list \
	echo_inst_files clean clobber install uninstall


############################################################
# Allow Makefile.local to change any of the above settings #
############################################################
include ${LOCAL_MKF}


###########################################
# all - First and default Makefile target #
###########################################

all: ${FULL_HELP_FILES} full ${DETAIL_HELP} ${DETAIL_CLONE} \
     ${SINGULAR_FILES} .all


###############################
# additional Makefile targets #
###############################

.PHONY: ${PHONY}

# used by the upper level Makefile to determine of we have done all
#
# NOTE: Due to bogus shells found on one common system we must have
#	an non-empty else clause for every if condition.  *sigh*
#
.all:
	${RM} -f .all
	${TOUCH} .all

bindings: ../cal/bindings
	${RM} -f $@
	${CP} ../cal/bindings $@
	${CHMOD} 0444 $@
	-@if [ -z "${Q}" ]; then \
	    echo ''; \
	    echo '=-=-= skipping the ${CAT} of help/$@ =-=-='; \
	    echo ''; \
	else \
	    ${TRUE}; \
	fi

resource: ../cal/README
	${RM} -f $@
	${CP} ../cal/README $@
	${CHMOD} 0444 $@
	-@if [ -z "${Q}" ]; then \
	    echo ''; \
	    echo '=-=-= skipping the ${CAT} of help/$@ =-=-='; \
	    echo ''; \
	else \
	    ${TRUE}; \
	fi

changes: ../CHANGES
	${RM} -f $@
	${CP} ../CHANGES $@
	${CHMOD} 0444 $@
	-@if [ -z "${Q}" ]; then \
	    echo ''; \
	    echo '=-=-= skipping the ${CAT} of help/$@ =-=-='; \
	    echo ''; \
	else \
	    ${TRUE}; \
	fi

libcalc: ../LIBRARY
	${RM} -f $@
	${SED} -e 's:$${LIBDIR}:${LIBDIR}:g' \
	       -e 's:$${CALC_INCDIR}:${CALC_INCDIR}:g' < ../LIBRARY > $@
	${CHMOD} 0444 $@
	-@if [ -z "${Q}" ]; then \
	    echo ''; \
	    echo '=-=-= skipping the ${CAT} of help/$@ =-=-='; \
	    echo ''; \
	else \
	    ${TRUE}; \
	fi

bugs: ../BUGS
	${RM} -f $@
	${CP} ../BUGS $@
	${CHMOD} 0444 $@
	-@if [ -z "${Q}" ]; then \
	    echo ''; \
	    echo '=-=-= skipping the ${CAT} of help/$@ =-=-='; \
	    echo ''; \
	else \
	    ${TRUE}; \
	fi

contrib: ../CONTRIB-CODE
	${RM} -f $@
	${CP} ../CONTRIB-CODE $@
	${CHMOD} 0444 $@
	-@if [ -z "${Q}" ]; then \
	    echo ''; \
	    echo '=-=-= skipping the ${CAT} of help/$@ =-=-='; \
	    echo ''; \
	else \
	    ${TRUE}; \
	fi

errorcodes: ../errcode${EXT}
	${RM} -f $@
	../errcode${EXT} -e > $@
	${CHMOD} 0444 $@
	-@if [ -z "${Q}" ]; then \
	    echo ''; \
	    echo '=-=-= skipping the ${CAT} of help/$@ =-=-='; \
	    echo ''; \
	else \
	    ${TRUE}; \
	fi

calc: ../calc.usage
	${RM} -f $@
	${CP} ../calc.usage $@
	${CHMOD} 0444 $@
	-@if [ -z "${Q}" ]; then \
	    echo ''; \
	    echo '=-=-= skipping the ${CAT} of help/$@ =-=-='; \
	    echo ''; \
	else \
	    ${TRUE}; \
	fi

../calc.usage:
	(cd ..; ${MAKE} -f ${MAKE_FILE} calc.usage)

custom_cal: ../custom/CUSTOM_CAL
	${RM} -f $@
	${CP} ../custom/CUSTOM_CAL $@
	${CHMOD} 0444 $@
	-@if [ -z "${Q}" ]; then \
	    echo ''; \
	    echo '=-=-= skipping the ${CAT} of help/$@ =-=-='; \
	    echo ''; \
	else \

=== debian/changelog ===
calc (2.15.1.0-1) unstable; urgency=medium

  * New upstream version 2.15.1.0
  * Update patches for new upstream release
  * Use dpkg buildtools.mk to determine compiler
  * Update uscan watch file to use github releases

 -- Martin Buck <mbuck@debian.org>  Mon, 06 Jan 2025 22:29:08 +0100

=== debian/control ===
Source: calc
Section: math
Priority: optional
Maintainer: Martin Buck <mbuck@debian.org>
Standards-Version: 4.4.0
Build-Depends: libreadline-dev, debhelper (>= 10), gcc (>= 4:4.1.1-7), bsdextrautils, groff-base
Homepage: http://www.isthe.com/chongo/tech/comp/calc/
Vcs-Browser: https://salsa.debian.org/mbuck/calc
Vcs-Git: https://salsa.debian.org/mbuck/calc.git

Package: calc
Architecture: any
Depends: calc-common (= ${source:Version}), sensible-utils, ${shlibs:Depends}, ${misc:Depends}
Replaces: apcalc (<< 2.12.7.2-3~)
Breaks: apcalc (<< 2.12.7.2-3~)
Description: Arbitrary precision calculator
 Calc is an arbitrary precision arithmetic system that uses a C-like
 language. Calc is useful as a calculator, an algorithm prototyper and as a
 mathematical research tool. More importantly, calc provides one with a
 machine independent means of computation. Calc comes with a rich set of
 builtin mathematical and programmatic functions.
 .
 Calc is built on top of the library libcalc that represents numeric values
 as fractions reduced to their lowest terms. This library can also be used
 to add arbitrary precision capabilities to your own programs and is
 available in the Debian package `calc-dev'.

Package: calc-common
Architecture: all
Depends: ${misc:Depends}
Replaces: apcalc-common (<< 2.12.7.2-3~)
Breaks: apcalc-common (<< 2.12.7.2-3~)
Description: Arbitrary precision calculator (common files)
 Calc is an arbitrary precision arithmetic system that uses a C-like
 language. Calc is useful as a calculator, an algorithm prototyper and as a
 mathematical research tool. More importantly, calc provides one with a
 machine independent means of computation. Calc comes with a rich set of
 builtin mathematical and programmatic functions.
 .
 This package contains architecture independent files required by the main
 package `calc'.

Package: calc-dev
Section: devel
Architecture: any
Depends: libc6-dev, sensible-utils, ${misc:Depends}
Suggests: calc
Replaces: apcalc-dev (<< 2.12.7.2-3~)
Breaks: apcalc-dev (<< 2.12.7.2-3~)
Description: Library for arbitrary precision arithmetic
 This package contains the library libcalc.a and the necessary header files
 which provide routines to handle arbitrary precision arithmetic with
 integers, rational numbers, or complex numbers. There are also many numeric
 functions such as factorial and gcd, along with some transcendental
 functions such as sin and exp.
 .
 This library is also used by the commandline calculator `calc', which is
 provided in the Debian package `calc'.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/buildflags.mk


INSTDIRARGS = SCRIPTDIR=/usr/share/doc/calc/examples


.PHONY: build
build: build-arch build-indep

.PHONY: build-arch
build-arch: build-stamp

.PHONY: build-indep
build-indep: build-stamp

build-stamp:
	dh_testdir

	# We always have to clean up first since we don't know which options were used
	# when building last time.
	-make clobber

	# First the library build. We build this without readline support to avoid
	# dependencies on libreadline in libcalc.
	make $(INSTDIRARGS) EXTRA_CFLAGS="$(CFLAGS) $(CPPFLAGS)" EXTRA_LDFLAGS="$(LDFLAGS)" LCC=$(CC)
ifeq (, $(filter nocheck,$(DEB_BUILD_OPTIONS)))
	make chk
endif

	# Clean up since we want to rebuild with different options below. But move the libraries
	# built above to a safe place first.
	mkdir -p debian/calc-dev-build
	mv libcalc.a debian/calc-dev-build
	mv custom/libcustcalc.a debian/calc-dev-build
	-make clobber
	
	# Now the build of the executable. This one uses readline.
	make $(INSTDIRARGS) EXTRA_CFLAGS="$(CFLAGS) $(CPPFLAGS)" EXTRA_LDFLAGS="$(LDFLAGS)" LCC=$(CC) \
	    USE_READLINE=-DUSE_READLINE READLINE_LIB=-lreadline
ifeq (, $(filter nocheck,$(DEB_BUILD_OPTIONS)))
	make chk
endif

	touch build-stamp

.PHONY: clean
clean:
	dh_testdir
	dh_testroot
	-rm -f build-stamp install-stamp

	-make clobber

	dh_clean
	-rm -fr debian/calc-dev-build

.PHONY: install
install: build-stamp
	dh_testdir
	dh_testroot
	dh_clean
	dh_installdirs

	make install $(INSTDIRARGS) T=$(shell pwd)/debian/calc

	# calc-dev
	mv debian/calc/usr/include/calc/*.h debian/calc-dev/usr/include/calc
	rmdir debian/calc/usr/include/calc/custom debian/calc/usr/include/calc debian/calc/usr/include
	cp debian/calc-dev-build/lib*calc.a debian/calc-dev/usr/lib
	cp sample_*.c debian/calc-dev/usr/share/doc/calc-dev/examples
	cp sample.README debian/calc-dev/usr/share/doc/calc-dev/examples/README
	# calc-common
	mv debian/calc/usr/share debian/calc-common/usr/share
	cd debian/calc-common/usr/share/doc && mv calc calc-common
	cd debian/calc-common/usr/share && mv calc/README doc/calc-common/README.calclib
	# calc
	rm debian/calc/usr/bin/calc-static debian/calc/usr/lib/libcalc.a debian/calc/usr/lib/libcustcalc.a
	rmdir debian/calc/usr/lib

	touch install-stamp

.PHONY: binary-indep
binary-indep: install
	dh_testdir -i
	dh_testroot -i
	dh_installdocs -pcalc-common BUGS README.md
	dh_installchangelogs -pcalc-common CHANGES
	dh_install -i
	dh_lintian -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

.PHONY: binary-arch
binary-arch: install
	dh_testdir -a
	dh_testroot -a
	dh_installdocs -pcalc-dev LIBRARY
	dh_installchangelogs -pcalc-dev CHANGES
	dh_link -pcalc usr/share/doc/calc-common usr/share/doc/calc
	dh_lintian -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

.PHONY: binary
binary: binary-indep binary-arch

.PHONY: get-orig-source
get-orig-source:
	cd $(dir $(firstword $(MAKEFILE_LIST)))/.. && \
	    uscan --verbose --force-download --rename --destdir $(CURDIR)

=== debian/watch ===
version=4
opts=searchmode=plain \
  https://api.github.com/repos/lcn2/calc/releases?per_page=100 \
  https://github\.com/lcn2/calc/releases/download/@ANY_VERSION@/calc-[^"]+@ARCHIVE_EXT@
